
#property copyright " 2008-2011 BJF Trading Group"
#property link      "www.iticsoftware.com"

#define vers   "1.0"


#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Silver
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1


extern int  RangeN = 7;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

double ExtMapBuffer1[];
double R2[];
double multiply;
int    PriceInt[];
int    SortInt[];


string short_name;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void init() 
{
  IndicatorBuffers(1);
    
  SetIndexStyle(0, DRAW_LINE);
  SetIndexBuffer(0, ExtMapBuffer1);
  ArrayResize(R2, RangeN);
  ArrayResize(PriceInt, RangeN );
  ArrayResize(SortInt, RangeN );

  multiply = MathPow(10, Digits);


  short_name = "Spearman("+RangeN +")";
  IndicatorShortName(short_name);

  IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS) + 1);
}

void deinit()
{
}

int  start() 
{  
   int counted_bars = IndicatorCounted();
//----
   int i, k, limit;
   if(counted_bars == 0)
     limit = Bars - RangeN ;
  
   if(counted_bars > 0)
       limit = Bars - counted_bars;
       
   for(i = limit; i >= 0; i--)
     {
       for(k = 0; k < RangeN ; k++) 
           PriceInt[k] = Close[i+k]*multiply;
       RankPrices(PriceInt);
       ExtMapBuffer1[i] = SpearmanRankCorrelation(R2,RangeN );
     }
//----
   return(0);
}

//+------------------------------------------------------------------+
//| calculate  RSP  function                                         |
//+------------------------------------------------------------------+
double SpearmanRankCorrelation(double Ranks[], int N)
  {
//----
   double res,z2;
   int i;
   for(i = 0; i < N; i++)
     {
       z2 += MathPow(Ranks[i] - i - 1, 2);
     }
   res = 1 - 6*z2 / (MathPow(N,3) - N);
//----
   return(res);
  }
//+------------------------------------------------------------------+
//| Ranking array of prices function                                 |
//+------------------------------------------------------------------+
void RankPrices(int InitialArray[])
  {
  
  //int Spear.SortDir = MODE_DESCEND;
  int Spear_SortDir = MODE_ASCEND;
  
//----
   int i, k, m, dublicat, counter, etalon;
   double dcounter, averageRank;
   double TrueRanks[];
   ArrayResize(TrueRanks, RangeN);
   ArrayCopy(SortInt, InitialArray);
   for(i = 0; i < RangeN; i++) 
       TrueRanks[i] = i + 1;

   ArraySort(SortInt, 0, 0, Spear_SortDir);

   for(i = 0; i < RangeN-1; i++)
     {
       if(SortInt[i] != SortInt[i+1]) 
           continue;
       dublicat = SortInt[i];
       k = i + 1;
       counter = 1;
       averageRank = i + 1;
       while(k < RangeN)
         {
           if(SortInt[k] == dublicat)
             {
               counter++;
               averageRank += k + 1;
               k++;
             }
           else
               break;
         }
       dcounter = counter;
       averageRank = averageRank / dcounter;
       for(m = i; m < k; m++)
           TrueRanks[m] = averageRank;
       i = k;
     }
   for(i = 0; i < RangeN; i++)
     {
       etalon = InitialArray[i];
       k = 0;
       while(k < RangeN)
         {
           if(etalon == SortInt[k])
             {
               R2[i] = TrueRanks[k];
               break;
             }
           k++;
         }
     }
//----
   return;
}

